
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_NETWORK_PIPE_SYMBOL_H
#define PGL_NETWORK_PIPE_SYMBOL_H

#include "pgl/HostsBasedSym.h"

// base class for robot and server symbols
class NetPipeSym: public HostsBasedSym {
	public:
		NetPipeSym();
		NetPipeSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		String kind() const;
		bool bandwidthBitsps(int &bps) const;
		bool queuePacketSize(int &size) const;
		bool queueByteSize(int &size) const;
		bool packetLoss(double &plr) const;
		RndDistr *packetDelay() const;
		bool incoming() const;
		bool outgoing() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
