/* 
 * %%nomodsWarning
 */

/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "pgl/PglExprSym.h"
#include "pgl/PglBoolSym.h"
#include "pgl/PglIntSym.h"
#include "pgl/PglNumSym.h"
#include "pgl/PglTimeSym.h"
#include "pgl/PglSizeSym.h"
#include "pgl/PglStringSym.h"
#include "pgl/PglQualifSym.h"
#include "pgl/PglKnownNamesSym.h"
#include "pgl/PglArraySym.h"
#include "pgl/PglListSym.h"

#include "pgl/pglSyms.h"
#include "pgl/PglSemx.h"
#include "pgl/PglParser.h"

typedef PglSemx LangSemx;

%%prelude

%%attrdef

%%code

PglParser::PglParser(Lexer *l) : GParser(l) {
	// static int _condTable[] = %%condTable;

	acceptState = %%acceptState;
	// condTable = _condTable;
	maxState = %%states;

	PglSemx::Init();
}

PglParser::~PglParser() {
	PglSemx::Done();
}

int PglParser::actionTable(int state, int sym) {
	static int _actionTable[%%states][%%symbols] = %%actionTable;
	return _actionTable[state][sym];
}

ReduceInfo *PglParser::reduceTable(int i) {
	static ReduceInfo _reduceTable[] = %%reduceTable;
	return(&_reduceTable[i]);
}

%%postlude
