
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SERVER_CONNECTION_MANAGER_H
#define PG_SERVER_CONNECTION_MANAGER_H

#include "runtime/ConnMgr.h"

class SrvConnMgr: public ConnMgr {
	public:
		class User {
			public:
				virtual ~User() {}
				virtual void noteConnReady(Connection *conn) = 0;
		};

	public:
		SrvConnMgr(User *aUser);

		void acceptLmt(int aLmt);

		bool accept(Socket &s); // false iff fatal error

		virtual void noteReadReady(int fd);
		
	protected:
		virtual void putIdle(Connection *conn);

	protected:
		User *theUser;
		int theAcceptLmt;
};

#endif
