
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/h/strstream.h"

#include "xml/XmlAttr.h"


XmlAttr::XmlAttr(): theNode(0) {
}

XmlAttr::XmlAttr(const XmlAttr &a): theNode(0), theName(a.theName), theValue(a.theValue) {
}

XmlAttr::XmlAttr(const String &aName, const String &aVal): 
	theNode(0), theName(aName), theValue(aVal) {
}


XmlAttr::XmlAttr(const String &aName, int aVal): 
	theNode(0), theName(aName) {
	char buf[16];
	ostrstream os(buf, sizeof(buf));
	os << aVal << ends;
	theValue = buf;
}


XmlAttr::~XmlAttr() {
	Assert(!theNode);
}

void XmlAttr::node(XmlNode *aNode) {
	Assert(!theNode || !aNode);
	theNode = aNode;
}

void XmlAttr::name(const String &aName) {
	theName = aName;
}

void XmlAttr::value(const String &aVal) {
	theValue = aVal;
}

ostream &XmlAttr::print(ostream &os, const String &pfx) const {
	os << pfx << theName << '=';
	const bool sqw = theValue.chr('\'');
	const bool dqw = theValue.chr('"');
	if (!dqw)
		os << '"' << theValue << '"';
	else
	if (!sqw)
		os << '\'' << theValue << '\'';
	else
		Assert(false); // XXX: should escape quotes instead
	return os;
}
