
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_NODE_H
#define PG_XML_NODE_H

#include "xstd/String.h"
#include "xstd/Array.h"

class ostream;
class String;
class XmlAttr;
class XmlAttrs;
class XmlNodes;

// an element of the XML document tree
class XmlNode {
	public:
		XmlNode();
		XmlNode(const XmlNode &);
		virtual ~XmlNode();

		virtual XmlNode *clone() const = 0;

		void parent(XmlNode *aParent);

		virtual XmlAttrs *attrs() { return 0; }
		virtual XmlNodes *kids() { return 0; }

		void addAttr(XmlAttr *attr);
		void addChild(XmlNode *kid);

		virtual ostream &print(ostream &os, const String &pfx) const = 0;

	protected:
		XmlNode *theParent;
};

inline
ostream &operator <<(ostream &os, const XmlNode &n) {
	static String empty("");
	n.print(os, empty);
	return os;
}

#endif
