
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "xstd/xstd.h"

#include "xstd/h/iostream.h"

#include "xstd/SrcLoc.h"


SrcLoc::SrcLoc(const String &aFName, int aLineNo):
	theFName(aFName), theLineNo(aLineNo) {
}

bool SrcLoc::sameLine(const SrcLoc &t) const {
	return theFName && theFName == t.theFName && theLineNo == t.theLineNo;
}

ostream &SrcLoc::print(ostream &os) const {
	if (theFName)
		os << theFName << ':' << theLineNo << ": ";
	return os;
}
